

// nodeset type
enum NodeType { Memory, Cache, Disk, CPU, Switch } ;

class Linkset;

class Nodeset {
private:
    char * name ;
    NodeType type ;
    int number ;
    float grainsize ;
    int bandwidth ;
    float floatspeed ;
    int cacherule ;
    int portcount ;
    char ** portname ;
    Linkset ** portlink ;
public:
    Nodeset() {};
    Nodeset(NodeType Type, int num, int port) ;
    ~Nodeset() ;
    void assign(float size) ;
    void assign(NodeType Type, int num, float size) ;
    void Nodeset::assign(float size, Linkset** link) ;
    void Nodeset::assign(Linkset** link) ;
    void Nodeset::display() ;
    calculate() ;
} ;



// linkset type 
enum Linktype { Updown, Across } ;
enum Duplex { Full, Half } ;

class Nodeset ;

class Linkset {
private:
    char * name ;
    Linktype type ;
//    Nodeset * nodesetbegin ;
//    Nodeset * nodesetend ;
    int topology ;
    Duplex duplex ;
    int number ;
    float latency ;
    int bandwidth ;
    int distribution ;

public:
    Linkset() {} ;
    Linkset(Linktype Type, Duplex dupl, int num) ;
    ~Linkset() ;
    void Linkset::assign(Nodeset* begin, Nodeset* end) ;
    void Linkset::display() ;
    void send() ;
} ;


Linkset::Linkset(Linktype Type, Duplex dupl, int num):
		type(Type), duplex(dupl), number(num) {}

Linkset::~Linkset() {}

void Linkset::assign(Nodeset* begin, Nodeset* end) {
//    nodesetbegin = begin ;
//    nodesetend = end ;
}

void Linkset::display() {
    cout << number << endl ;
}
